find_package(Doxygen REQUIRED dot)

configure_file(doxygen/footer.html ${CMAKE_CURRENT_BINARY_DIR}/doxygen/footer.html)

if(BUILD_VERSION MATCHES "1.99.99")
    set(DOXYGEN_PROJECT_NUMBER " ")
else()
    set(DOXYGEN_PROJECT_NUMBER "\"${BUILD_VERSION}\"")
endif()
set(DOXYGEN_PROJECT_NAME "${LABEL_NAME}")
set(DOXYGEN_GENERATE_TREEVIEW YES)
set(DOXYGEN_USE_MDFILE_AS_MAINPAGE README.md)
set(DOXYGEN_EXTENSION_MAPPING "no_extension=md")
set(DOXYGEN_HTML_EXTRA_STYLESHEET "${CMAKE_CURRENT_SOURCE_DIR}/doxygen/dw.css")
set(DOXYGEN_HTML_FOOTER "${CMAKE_CURRENT_BINARY_DIR}/doxygen/footer.html")
set(DOXYGEN_LAYOUT_FILE "${CMAKE_CURRENT_SOURCE_DIR}/doxygen/DoxygenLayout.xml")
set(DOXYGEN_HTML_COLORSTYLE_HUE 142)
set(DOXYGEN_HTML_COLORSTYLE_SAT 58)
set(DOXYGEN_DOT_IMAGE_FORMAT "svg")
set(DOXYGEN_QUIET YES)

file(GLOB STATIC_MARKDOWN_PAGES
    "${CMAKE_CURRENT_SOURCE_DIR}/html/*.md"
    "${CMAKE_SOURCE_DIR}/examples/*.md"
)

doxygen_add_docs(${PROJECT_NAME}_doc
    ${CMAKE_SOURCE_DIR}/LICENSE
    ${CMAKE_SOURCE_DIR}/README.md
    ${CMAKE_SOURCE_DIR}/RELEASENOTES.md
    ${CMAKE_CURRENT_SOURCE_DIR}/license/3rd_party_licenses.md
    ${STATIC_MARKDOWN_PAGES}
    ALL
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    COMMENT "Generating Doxygen Documentation"
)

set_property(TARGET ${PROJECT_NAME}_doc PROPERTY FOLDER doc)

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/mainpage.html DESTINATION doc/)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html/ DESTINATION doc/html)
